package com.qmth.jkserver.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.jkserver.config.DictionaryConfig;
import com.qmth.jkserver.constant.SystemConstant;
import com.qmth.jkserver.dao.BasicSchoolDao;
import com.qmth.jkserver.model.BasicSchool;
import com.qmth.jkserver.service.BasicSchoolService;
import com.qmth.jkserver.service.CommonCacheService;
import com.qmth.jkserver.util.FileStoreUtil;
import org.springframework.context.annotation.Scope;
import org.springframework.context.annotation.ScopedProxyMode;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.util.Base64;

/**
 * <p>
 * 学校表 服务实现类
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
@Service
@Scope(proxyMode = ScopedProxyMode.INTERFACES)
public class BasicSchoolServiceImpl extends ServiceImpl<BasicSchoolDao, BasicSchool> implements BasicSchoolService {

    @Resource
    DictionaryConfig dictionaryConfig;

    @Resource
    FileStoreUtil fileStoreUtil;

    @Resource
    CommonCacheService commonCacheService;

    @Override
    public boolean updateSchool(Long id, String code, String name, MultipartFile logo, String logoMd5) {
        BasicSchool basicSchool = this.getById(id);
        basicSchool.setCode(code);
        basicSchool.setName(name);

        if (logo != null) {
            try {
                String toBase64 = "data:image/png;base64," + new String(Base64.getEncoder().encode(logo.getBytes()), SystemConstant.CHARSET);
                basicSchool.setLogo(toBase64);
            } catch (Exception e) {
                log.error(SystemConstant.LOG_ERROR, e);
            } finally {
                commonCacheService.removeSchoolCache(basicSchool.getCode());
                commonCacheService.removeSchoolCache(basicSchool.getId());
            }
        }
        return this.updateById(basicSchool);
    }
}
